/****************************************************************************
Copyright (c) 1999-2007 
Maryland DSPCAD Research Group, The University of Maryland at College Park 

Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that the above
copyright notice and the following two paragraphs appear in all copies
of this software.

IN NO EVENT SHALL THE UNIVERSITY OF MARYLAND BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF MARYLAND HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF MARYLAND SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
MARYLAND HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.
******************************************************************************/
import mapss.dif.language.Reader;
import mapss.dif.language.DIFLanguageException;
import mapss.dif.csdf.sdf.SDFGraph;
import java.io.IOException;
import java.util.HashMap;
import java.util.Set;
import java.util.Iterator;
import java.util.Collection;
import mocgraph.Node;

public class QuickStartDemo2 {
    public static void main(String[] args) {
        try {
            Reader reader = new Reader(args[0]);
            reader.compile();

            Collection graphs = reader.getGraphs();
            Iterator graphsIterator = graphs.iterator();

            while(graphsIterator.hasNext()){
                SDFGraph graph = (SDFGraph)graphsIterator.next();
                HashMap graphHM = graph.computeRepetitions();
                Set hmSet = graphHM.keySet();
                Iterator hmIter = hmSet.iterator();

                while(hmIter.hasNext()){
                    Node node = (Node)hmIter.next();
                    System.out.println(
                                       graph.getRepetitions(node) + "\t" +
                                       graph.getName(node));
                }

                System.out.println();
                System.out.println("Buffer memory upper bound = " +
                                   graph.BMUB());
            }
        } catch (IOException exp) {
            throw new RuntimeException(exp.getMessage());
        } catch (DIFLanguageException exp) {
            throw new RuntimeException(exp.getMessage());
        }
    }
}

